#!/usr/local/bin/perl

print "\nViper v1.2 5/3/1999\n\n";

$arg_length = @ARGV;
$file = "";
$user = "";
$char = 1;
$pwl = 12;
$ui = 100000;

# need help?

if($ARGV[0] eq "-h" || $ARGV[0] eq "-?" || $ARGV[0] eq "") { &help; }

# process command line arguments

for($i=0;$i<$arg_length;$i++) {
 if($ARGV[$i] eq "-f") { $file = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-u") { $user = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-c") { $char = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-pwl") { $pwl = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-ui") { $ui = $ARGV[$i+1]; $i++; }
 }

# check for required arguments

if($file eq "" || $user eq "") {
 print "Both the password file and user name are required\n";
 die "\n";
 }

# attempt to load account from file

open(IN,$file) || die "Could not open password file $file\n";
$pass = "";
while(<IN>) {
 chop($_);
 @sort = split(/:/,$_);
 if(@sort[0] eq $user) { $epass = @sort[1]; }
 }
close(IN);
if($epass eq "") { die "User $user could not be found in $file\n"; }
$pl = length($epass);
if($pl < 4) { die "Bad password for user $user\n"; } # decent guess here
print "Found user $user \(pw:$epass\)\n";

# load character set

open(IN,"charset.ini") || die "Could not open charset.ini\n";
$charset = "";
while(<IN>) {
 chop($_);
 @sort = split(/:/,$_);
 if(@sort[0] eq $char) { $charset = @sort[1]; }
 }
close(IN);
if($charset eq "") { die "Could not load character set index $char\n"; }
$pl = length($charset);

# get current time and get initial time since 1/1/1970

$sloctime = localtime();
$stime = time();
$ltime = $stime;

# display info and start

print "Character set $char loaded with $pl character length\n";
print "There are a total of $pl\^$pwl possible passwords in this run\n";
print "Starting crack on $sloctime\n\n";

&crack($user,$epass,$charset,$mail,$pwl,$ui);

sub help {
 print "   -f <file>    File to load password from (required)\n";
 print "   -u <user>    Username to load from file (required)\n";
 print "   -c #         Character set from charset.ini to use (default 1)\n";         
 print "   -pwl #       Maximum password length (default 12)\n";
 print "   -ui #        Console update interval (default 100000)\n";
 die "\n";
 }

sub crack {
 my($user,$epass,$charset,$mail,$pwl,$ui,$mail) = @_;
 @vars = split(//,$charset);
 $varlen = @vars;
 $count = 0;
 $refresh = 0;

 $salt = substr($epass,0,2); 
 for($i=0;$i<$pwl;$i++) {
  ### make new password ###
  $it = $i+1;
  for($j=0;$j<$it;$j++) { @pass[$j] = 0; }
  
  print "Cracking for pass length \[$it\]\n";

  ### start loop for this length ###
  while(@pass[0] ne $varlen) {
   $count++;
   $refresh++;   

   ### make actual password out of array ###
   $pass = "";
   for($y=0;$y<@pass;$y++) { $pass = $pass . @vars[@pass[$y]]; }
   ## - done - ##
   
   ### Here is where the magic happens ###
   $cpass = crypt($pass,$salt); # the point of the whole script
   if($epass eq $cpass) {
    $refresh  = 0;
    $count = 0;
    $realpass = $pass;
    $i = 999;
    @pass[0] = $varlen;
    }         

   if($count eq $ui) {
    # calculate duration and cps
    $ctime = time();
    $totdur = $ctime - $stime;
    $temp_dur = $ctime - $ltime;
    $ltime = $ctime;
    $cps = int $ui / $temp_dur;

    #change second format into hh:mm:ss

    $dur = &convert($totdur);

    #display data

    print "[ Length : $it \| Last: $pass \| CPS: $cps | Time : $dur ]\n";
    $count = 0;
    }
   ## whee... ##   

   ### create next password array ###
   $l = @pass;
   $l--;
   @pass[$l]++;   # wow.. this is an important line... 
   for($r=$l;$r>0;$r--) { if(@pass[$r] eq $varlen) { @pass[$r-1]++; @pass[$r] = 0; } }
   ## done with that ###
   }
  }

 if($realpass ne "") { 
  $loctime = localtime();
  $etime = time();
  $ttime = $etime - $stime;
  $duration = &convert($ttime);
  $message = "
  The password has been located!
  Username : $user 
  Password : $realpass
  Started  : $sloctime
  Finished : $loctime
  Time     : $duration
  ";
  } else {
  $message = "
  The password could not be located
  Username : $user 
  Password : ???
  Started  : $sloctime
  Finished : $loctime
  Time     : $duration
  ";
   }
  print "$message\n";
 }

sub convert {
 my($totdur) = @_;
 for($vt=0;$vt<3;$vt++) { @vta[$vt] = 0; }
 @vta[0] = $totdur;
 for($vt=@vta[0];@vta[0]>59;$vt++) { @vta[1]++; @vta[0] -= 60; }
 for($vt=@vta[1];@vta[1]>59;$vt++) { @vta[2]++; @vta[1] -= 60; }
 for($vt=0;$vt<3;$vt++) {  # pad zeros
  $len = length(@vta[$vt]);
  if($len eq 1) { @vta[$vt] = "0" . @vta[$vt]; } 
  }
 $dur = @vta[2] . ":" . @vta[1] . ":" . @vta[0];
 return $dur;
 }

